' xProp.VBS V1.07 (C) yoshioka.teruo@nifty.com 2006-01-21
' xProp.VBS shows extended properties of file etc. on IE window.
' Usage: xProp {file|folder|drive}

Option Explicit
Dim fso
Dim Shell
Dim arg
Dim ParentFolder
Dim FileName
Dim Folder
Dim FolderItem
Dim ie

Set fso=CreateObject("Scripting.FileSystemObject")
Set Shell=CreateObject("Shell.Application")

For Each arg In WScript.Arguments
  arg=fso.GetAbsolutePathName(arg)
  ParentFolder=fso.GetParentFolderName(arg)
  If ParentFolder<>"" Then
    FileName=fso.GetFileName(arg)
  Else
    ParentFolder=17
    FileName=arg
  End If
  Set Folder=Shell.NameSpace(ParentFolder)
  If Folder Is Nothing Then
    WScript.Echo ParentFolder,"Not Found."
  Else
    Set FolderItem=Folder.ParseName(FileName)
    If FolderItem Is Nothing Then
      WScript.Echo FileName,"Not Found."
    Else
      Call xProp(FolderItem,Folder)
    End If
  End If
Next
If WScript.Arguments.Count=0 Then
  Set ie=Shell.Windows().Item()
  If ie Is Nothing Then
  ElseIf ie.ReadyState<>4 Then
  ElseIf ie.Busy Then
  ElseIf InStr(TypeName(ie.Document),"IShellFolderViewDual") Then
    Call xProp(ie.Document.FocusedItem,ie.Document.Folder)
  End If
End If
WScript.Quit

Function xProp(FolderItem,Folder)
If UCase(fso.GetBaseName(WScript.FullName))="CSCRIPT" Then
  Call cProp(FolderItem,Folder)
Else
  Call wProp(FolderItem,Folder)
End If
End Function

Function wProp(FolderItem,Folder)
Dim ie
Dim k
Dim COL:COL=50
Dim oTABLE
Dim Name
Dim Value
Dim TextFile

Set ie=CreateObject("InternetExplorer.Application")
ie.ToolBar=False
'ie.StatusBar=False
'ie.AddressBar=False
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.designMode="On"
ie.Document.charset="shift_jis"
ie.Document.title=FolderItem.Path
ie.Document.parentWindow.defaultStatus="vpeBy[W쐬Ă܂..."
ie.Visible=True
If Not ie.Document.hasFocus Then
  Dim wShell
  Set wShell=CreateObject("WScript.Shell")
  wShell.SendKeys "%{Tab}"
  WScript.Sleep 100
  wShell.AppActivate ie.Document.Title
End If
ie.Document.body.innerHTML="<table id='oTABLE' border=1></table>" 
Set oTABLE=ie.Document.all.oTABLE

'"InfoTip"="prop:Type;DocAuthor;DocTitle;DocSubject;DocComments;Write;Size"

insertRow oTABLE,"p","Path",FolderItem.Path 
insertRow oTABLE,"x","Directory",FolderItem.ExtendedProperty("Directory") 
insertRow oTABLE,"p","Name",FolderItem.Name 
insertRow oTABLE,"x","Name",FolderItem.ExtendedProperty("Name") 
insertRow oTABLE,"p","Size",FolderItem.Size 
insertRow oTABLE,"x","Size",FolderItem.ExtendedProperty("Size") 
insertRow oTABLE,"p","ModifyDate",FolderItem.ModifyDate 
insertRow oTABLE,"x","Write",FolderItem.ExtendedProperty("Write") 
insertRow oTABLE,"x","Create",FolderItem.ExtendedProperty("Create") 
insertRow oTABLE,"x","Access",FolderItem.ExtendedProperty("Access") 
insertRow oTABLE,"p","Type",FolderItem.Type 
insertRow oTABLE,"x","Type",FolderItem.ExtendedProperty("Type") 
insertRow oTABLE,"p","IsFolder",FolderItem.IsFolder
insertRow oTABLE,"p","IsLink",FolderItem.IsLink
insertRow oTABLE,"p","IsBrowsable",FolderItem.IsBrowsable
insertRow oTABLE,"x","Attributes",FolderItem.ExtendedProperty("Attributes") 
For k=-1 To COL
  Name=Folder.GetDetailsOf(,k) 
  If k=-1 Then Name=Replace("Type;DocAuthor;DocTitle;DocSubject;DocComments;Write;Size",";",vbCrLf)
  Value=Folder.GetDetailsOf(FolderItem,k) 
  If Name<>"" Or Value<>"" Then
    insertRow oTABLE,k,Name,Value 
  End If
Next
If fso.FileExists(FolderItem.Path&":Zone.Identifier") Then
  Set TextFile=fso.OpenTextFile(FolderItem.Path&":Zone.Identifier")
  Name=TextFile.ReadLine()
  Value=TextFile.ReadLine()
  insertRow oTABLE,"z",Name,Value 
End If
ie.Document.designMode="Off"
ie.Document.parentWindow.defaultStatus="vpeBy[W쐬܂"
End Function

Function cProp(FolderItem,Folder)
Dim k
Dim COL:COL=50
Dim Name
Dim Value
Dim TextFile

WScript.Echo "p","Path",FolderItem.Path 
WScript.Echo "x","Directory",FolderItem.ExtendedProperty("Directory") 
WScript.Echo "p","Name",FolderItem.Name 
WScript.Echo "x","Name",FolderItem.ExtendedProperty("Name") 
WScript.Echo "p","Size",FolderItem.Size 
WScript.Echo "x","Size",FolderItem.ExtendedProperty("Size") 
WScript.Echo "p","ModifyDate",FolderItem.ModifyDate 
WScript.Echo "x","Write",FolderItem.ExtendedProperty("Write") 
WScript.Echo "x","Create",FolderItem.ExtendedProperty("Create") 
WScript.Echo "x","Access",FolderItem.ExtendedProperty("Access") 
WScript.Echo "p","Type",FolderItem.Type 
WScript.Echo "x","Type",FolderItem.ExtendedProperty("Type") 
WScript.Echo "p","IsFolder",FolderItem.IsFolder
WScript.Echo "p","IsLink",FolderItem.IsLink
WScript.Echo "p","IsBrowsable",FolderItem.IsBrowsable
WScript.Echo "x","Attributes",FolderItem.ExtendedProperty("Attributes") 
For k=-1 To COL
  Name=Folder.GetDetailsOf(,k) 
  Value=Folder.GetDetailsOf(FolderItem,k) 
  If Name<>"" Or Value<>"" Then
    WScript.Echo k,Name,Value 
  End If
Next
If fso.FileExists(FolderItem.Path&":Zone.Identifier") Then
  Set TextFile=fso.OpenTextFile(FolderItem.Path&":Zone.Identifier")
  Name=TextFile.ReadLine()
  Value=TextFile.ReadLine()
  WScript.Echo "z",Name,Value 
End If
End Function

Sub insertRow(oTABLE,k,Name,Value)
Dim oTR
Dim oTD
Set oTR=oTABLE.insertRow 
Set oTD=oTR.insertCell 
oTD.InnerText=k
Set oTD=oTR.insertCell 
oTD.InnerText=Name
Set oTD=oTR.insertCell 
oTD.InnerText=Value
End Sub 
